/*
 * HTTPcat, on GNU license.
 * Author: Andrzej Godziuk (GDR!)
 * http://www.GDR.w.pl/
 */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <winsock.h>
#include <winbase.h>
#include <string.h>

HWND g_hwnd;

#include "net.h"
#include "resource.h"
#include "Mystring.c"
#include "actions.c"


BOOL CALLBACK AutoReqDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	static char *oldreq, *oldport, *oldhost;

	switch(Message)
	{
		case WM_INITDIALOG:
			{
				HWND hCtl;
				int len;

				hCtl = GetDlgItem(g_hwnd, IDC_REQUEST);
				len = GetWindowTextLength(hCtl);
				oldreq = malloc(len+2);
				if(!oldreq) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
				GetWindowText(hCtl, oldreq, len+1);

				hCtl = GetDlgItem(g_hwnd, IDC_PORT);
				len = GetWindowTextLength(hCtl);
				oldport = malloc(len+2);
				if(!oldport) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
				GetWindowText(hCtl, oldport, len+1);

				hCtl = GetDlgItem(g_hwnd, IDC_HOST);
				len = GetWindowTextLength(hCtl);
				oldhost = malloc(len+2);
				if(!oldhost) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
				GetWindowText(hCtl, oldhost, len+1);

				CheckDlgButton(hwnd, IDC_DOCLOSE, BST_CHECKED);

				/* fill combo */
				hCtl = GetDlgItem(hwnd, IDC_MODE);
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Simple (HTTP/1.0)");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Simple (HTTP/1.1)");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Header only (HTTP/1.0)");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Microsoft Internet Explorer 5 - like");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Microsoft Internet Explorer 6 - like");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Opera - like");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Mozilla - like");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"FlashGet - like");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"Voyager - like");
				SendMessage(hCtl, CB_ADDSTRING, (WPARAM)0, (LPARAM)"IBrowse - like");
				SendMessage(hCtl, CB_SETCURSEL, (WPARAM)1, (LPARAM)0);

			}
		break;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case IDOK:
				{
					char *url, *host, *path, *buf, *useragent;
					int port, len, mode = REQ_SIMPLE10;
					HWND hCtl;

					hCtl = GetDlgItem(hwnd, IDC_URL);
					len = GetWindowTextLength(hCtl);
					url= malloc(len+1);
					if(!url) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
					GetWindowText(hCtl, url, len+1);
					host= malloc(len+1);
					if(!host) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
					path= malloc(len+1);
					if(!path) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
					buf = malloc(16384 + 3*len);
					hCtl = GetDlgItem(hwnd, IDC_AGENT);
					len = GetWindowTextLength(hCtl);
					useragent= malloc(len+2);
					GetWindowText(hCtl, useragent, len+1);

					hCtl = GetDlgItem(hwnd, IDC_MODE);
					mode = SendMessage(hCtl, CB_GETCURSEL, 0, 0);


					parseurl(url, host, &port, path);

					makerequest(buf, path, port, host, useragent, mode);


					hCtl = GetDlgItem(g_hwnd, IDC_HOST);
					SetWindowText(hCtl, host);
					hCtl = GetDlgItem(g_hwnd, IDC_REQUEST);
					SetWindowText(hCtl, buf);
					sprintf(buf, "%d", port);
					hCtl = GetDlgItem(g_hwnd, IDC_PORT);
					SetWindowText(hCtl, buf);

					free(buf);
					free(host);
					free(path);
					free(url);

					if(IsDlgButtonChecked(hwnd, IDC_DOCLOSE)==BST_CHECKED)
					{
						if(oldreq) {free(oldreq); oldreq=0;}
						if(oldport) {free(oldport); oldport=0;}
						if(oldhost) {free(oldhost); oldhost=0;}
						EndDialog(hwnd, 0);
					}
				}
				break;
			case IDCANCEL:
				{
					HWND hCtl;

					hCtl = GetDlgItem(g_hwnd, IDC_REQUEST);
					SetWindowText(hCtl, oldreq);
					if(oldreq) {free(oldreq); oldreq=0;}

					hCtl = GetDlgItem(g_hwnd, IDC_HOST);
					SetWindowText(hCtl, oldhost);
					if(oldhost) {free(oldhost); oldhost=0;}

					hCtl = GetDlgItem(g_hwnd, IDC_PORT);
					SetWindowText(hCtl, oldport);
					if(oldport) {free(oldport); oldport=0;}

					EndDialog(hwnd,0);
				}
			}
		break;
		case WM_CLOSE:
			if(oldreq) {free(oldreq); oldreq=0;}
			if(oldport) {free(oldport); oldport=0;}
			if(oldhost) {free(oldhost); oldhost=0;}
			EndDialog(hwnd, 0);
		break;

		default:
			return FALSE;
	}
	return TRUE;
}


BOOL CALLBACK DlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{

	switch(Message)
	{
		case WM_INITDIALOG:
			{
				HWND hctl;
				hctl = GetDlgItem(hwnd, IDC_HOST);
				SetWindowText(hctl, "localhost");

				hctl = GetDlgItem(hwnd, IDC_PORT);
				SetWindowText(hctl, "80");

				hctl = GetDlgItem(hwnd, IDC_REQUEST);
				SetWindowText(hctl, "GET / HTTP/1.0\r\n");
				
				g_hwnd = hwnd;

			}
//			GetScrollRange(GetDlgItem(hwnd, IDC_EDIT), SB_VERT, &t, &maxscroll);

		break;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case IDSEND:
				mydialog("dupa");
				idsend(hwnd);
				break;
			case IDC_RESPONSEFILE:
				selectsavefile(hwnd);
				break;
			case IDC_SAVERESPONSEHEADER:
				saveresponseheader(hwnd);
			case IDC_REPEATED:
				break;
			case IDFILL:
				DialogBox(0, MAKEINTRESOURCE(IDD_AUTOREQ), hwnd, AutoReqDlgProc);
				break;
			case IDC_FOLLOW302:
				f302(hwnd);
				break;
			case IDC_COOKIES:
				passcookies(hwnd);
				break;
			case IDC_QFR:
				{
					char *url;

					gettext(hwnd, IDC_QURL, &url);
					recvurl(url);
					free(url);
				}
				break;
			case IDC_TOIP:
				{
					hosttoip(hwnd);
				}
				break;
			case IDC_BUTTON1:
				{
					MessageBox(hwnd, "You've found the hidden part! ;]", "Congratulations!", 0);
				}
				break;
			}
		break;
		case WM_CLOSE:
			EndDialog(hwnd, 0);
		break;

		default:
			return FALSE;
	}
	return TRUE;
}



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	int err;
	WSADATA wsaData;

	err=WSAStartup(MAKEWORD(1, 1), &wsaData);

#ifndef FINAL
	printf("WSA Startup() : %d\n", err);
#endif

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProc);
	WSACleanup();

	return 0;

}


